FROM mcr.microsoft.com/dotnet/aspnet:6.0 AS base
WORKDIR /app
EXPOSE 5000
EXPOSE 50051

ENV ASPNETCORE_URLS=http://+:5000

# Creates a non-root user with an explicit UID and adds permission to access the /app folder
# For more info, please refer to https://aka.ms/vscode-docker-dotnet-configure-containers
RUN adduser -u 5678 --disabled-password --gecos "" appuser && chown -R appuser /app
USER appuser

FROM mcr.microsoft.com/dotnet/sdk:6.0 AS build
WORKDIR /src
COPY ["mariia-master/ReplicatedLog.Master.Api6/ReplicatedLog.Master.Api6.csproj", "mariia-master/ReplicatedLog.Master.Api6/"]
RUN dotnet restore "mariia-master/ReplicatedLog.Master.Api6/ReplicatedLog.Master.Api6.csproj"
COPY . .
WORKDIR "/src/mariia-master/ReplicatedLog.Master.Api6"
RUN dotnet build "ReplicatedLog.Master.Api6.csproj" -c Release -o /app/build

FROM build AS publish
RUN dotnet publish "ReplicatedLog.Master.Api6.csproj" -c Release -o /app/publish /p:UseAppHost=false

FROM base AS final
WORKDIR /app
COPY --from=publish /app/publish .
ENTRYPOINT ["dotnet", "ReplicatedLog.Master.Api6.dll"]
